#include <String.h>
#include <View.h>
#include <Box.h>
#include <Screen.h>
#include <TextControl.h>
#include <RadioButton.h>
#include <Message.h>

#include <stdio.h>
#include <malloc.h>

#include "setup.h"
#include "embossStringView.h"

#define WINDOW_XDIM					390
#define WINDOW_YDIM					250	
#define WINDOW_TITLE				"Framework Setup"

#define FRMWRKVIEW_XDIM				360
#define	FRMWRKVIEW_YDIM				135
#define FRMWRKVIEW_X0				15
#define FRMWRKVIEW_Y0				45
#define FRMWRKVIEW_X1				(FRMWRKVIEW_X0 + FRMWRKVIEW_XDIM - 1)
#define FRMWRKVIEW_Y1				(FRMWRKVIEW_Y0 + FRMWRKVIEW_YDIM - 1)
#define FRMWRKVIEW_LABEL			"Framework type"

#define PIXFMTVIEW_NAME				"pixel_format"
#define PIXFMTVIEW_XDIM				360
#define	PIXFMTVIEW_YDIM				70
#define PIXFMTVIEW_X0				15
#define PIXFMTVIEW_Y0				200
#define PIXFMTVIEW_X1				(PIXFMTVIEW_X0 + PIXFMTVIEW_XDIM - 1)
#define PIXFMTVIEW_Y1				(PIXFMTVIEW_Y0 + PIXFMTVIEW_YDIM - 1)
#define PIXFMTVIEW_LABEL			"Pixel format"

#define RINGBUFFCTRL_NAME			"num_ring_buffers"
#define RINGBUFFCTRL_XDIM			350
#define RINGBUFFCTRL_YDIM			20
#define RINGBUFFCTRL_X0				15
#define RINGBUFFCTRL_Y0				10
#define RINGBUFFCTRL_X1				(RINGBUFFCTRL_X0 + RINGBUFFCTRL_XDIM - 1)
#define RINGBUFFCTRL_Y1				(RINGBUFFCTRL_Y0 + RINGBUFFCTRL_YDIM - 1)
#define RINGBUFFCTRL_LABEL			"Number of ring buffers"
#define RINGBUFFCTRL_TXT_SIZER		"00000000"

#define	FRMWRK_DESC_OFFSET_X		120

#define FRMWRKCTRL_NULL_NAME		PARA_FRAMEWORK_NULL
#define FRMWRKCTRL_NULL_XDIM		350
#define FRMWRKCTRL_NULL_YDIM		20
#define FRMWRKCTRL_NULL_X0			15
#define FRMWRKCTRL_NULL_Y0			20
#define FRMWRKCTRL_NULL_X1			(FRMWRKCTRL_NULL_X0 + FRMWRKCTRL_NULL_XDIM - 1)
#define FRMWRKCTRL_NULL_Y1			(FRMWRKCTRL_NULL_Y0 + FRMWRKCTRL_NULL_YDIM - 1)
#define FRMWRKCTRL_NULL_LABEL		"Null"
#define FRMWRKCTRL_NULL_DESC		DESC_FRAMEWORK_NULL

#define FRMWRKCTRL_BVIEW_NAME		PARA_FRAMEWORK_BVIEW
#define FRMWRKCTRL_BVIEW_XDIM		350
#define FRMWRKCTRL_BVIEW_YDIM		20
#define FRMWRKCTRL_BVIEW_X0			15
#define FRMWRKCTRL_BVIEW_Y0			40
#define FRMWRKCTRL_BVIEW_X1			(FRMWRKCTRL_BVIEW_X0 + FRMWRKCTRL_BVIEW_XDIM - 1)
#define FRMWRKCTRL_BVIEW_Y1			(FRMWRKCTRL_BVIEW_Y0 + FRMWRKCTRL_BVIEW_YDIM - 1)
#define FRMWRKCTRL_BVIEW_LABEL		"BView with BBitmap"
#define FRMWRKCTRL_BVIEW_DESC		DESC_FRAMEWORK_BVIEW

#define FRMWRKCTRL_BDWIN_NAME		PARA_FRAMEWORK_BDWIN
#define FRMWRKCTRL_BDWIN_XDIM		350
#define FRMWRKCTRL_BDWIN_YDIM		20
#define FRMWRKCTRL_BDWIN_X0			15
#define FRMWRKCTRL_BDWIN_Y0			60
#define FRMWRKCTRL_BDWIN_X1			(FRMWRKCTRL_BDWIN_X0 + FRMWRKCTRL_BDWIN_XDIM - 1)
#define FRMWRKCTRL_BDWIN_Y1			(FRMWRKCTRL_BDWIN_Y0 + FRMWRKCTRL_BDWIN_YDIM - 1)
#define FRMWRKCTRL_BDWIN_LABEL		"BDirectWindow"
#define	FRMWRKCTRL_BDWIN_DESC		DESC_FRAMEWORK_BDWIN

#define FRMWRKCTRL_BDWINLC_NAME		PARA_FRAMEWORK_BDWINLC
#define FRMWRKCTRL_BDWINLC_XDIM		350
#define FRMWRKCTRL_BDWINLC_YDIM		20
#define FRMWRKCTRL_BDWINLC_X0		15
#define FRMWRKCTRL_BDWINLC_Y0		80
#define FRMWRKCTRL_BDWINLC_X1		(FRMWRKCTRL_BDWINLC_X0 + FRMWRKCTRL_BDWINLC_XDIM - 1)
#define FRMWRKCTRL_BDWINLC_Y1		(FRMWRKCTRL_BDWINLC_Y0 + FRMWRKCTRL_BDWINLC_YDIM - 1)
#define FRMWRKCTRL_BDWINLC_LABEL	"BDirectWindowLC"
#define	FRMWRKCTRL_BDWINLC_DESC		DESC_FRAMEWORK_BDWINLC

#define FRMWRKCTRL_BWINSCR_NAME		PARA_FRAMEWORK_BWINSCR
#define FRMWRKCTRL_BWINSCR_XDIM		350
#define FRMWRKCTRL_BWINSCR_YDIM		20
#define FRMWRKCTRL_BWINSCR_X0		15
#define FRMWRKCTRL_BWINSCR_Y0		100
#define FRMWRKCTRL_BWINSCR_X1		(FRMWRKCTRL_BWINSCR_X0 + FRMWRKCTRL_BWINSCR_XDIM - 1)
#define FRMWRKCTRL_BWINSCR_Y1		(FRMWRKCTRL_BWINSCR_Y0 + FRMWRKCTRL_BWINSCR_YDIM - 1)
#define FRMWRKCTRL_BWINSCR_LABEL	"BWindowScreen"
#define FRMWRKCTRL_BWINSCR_DESC		DESC_FRAMEWORK_BWINSCR

#define PIXFORMAT_GRID_COLUMNS		3
#define PIXFORMAT_GRID_X			120
#define PIXFORMAT_GRID_Y			20
#define PIXFORMAT_MARGIN_X			15	
#define PIXFORMAT_MARGIN_Y			20

#define MSG_CMD_CONTROL_CHANGED		'CTRL'
#define MSG_FLD_INVOKED				"invoked"

enum MSG_FLD_INVOKED_TYPE
{
	INVOKED_RINGBUFFCTRL,

	INVOKED_FRMWRKCTRL_NULL,
	INVOKED_FRMWRKCTRL_BVIEW,
	INVOKED_FRMWRKCTRL_BDWIN,
	INVOKED_FRMWRKCTRL_BDWINLC,
	INVOKED_FRMWRKCTRL_BWINSCR,

	INVOKED_PIXFMTCTRL_BASE
};

// window /////////////////////////////////////////////////////////////////////

SetupWindow::SetupWindow(AppParams & params) : 

	BWindow(BRect(0, 0, WINDOW_XDIM - 1, WINDOW_YDIM - 1), WINDOW_TITLE,
			B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE | B_ASYNCHRONOUS_CONTROLS),

	mParams(params),
	mDesktopPixFormat(NULL)
{
	BScreen *screen = new BScreen(this);

	// make note of the desktop color space
	color_space desktopColorSpace = (*screen).ColorSpace();

	// check the available screen pixel formats
	display_mode *listModes;
	uint32 nModes;

	(*screen).GetModeList(&listModes, &nModes);

	for (uint32 mi = 0; mi < nModes; mi++)
		for (uint32 fi = 0; fi < AppParams::nPixFormats; fi++)
			if (listModes[mi].space == (uint32) AppParams::pixFmtTxt[fi].space && !mPixFormats.HasItem((void *)(AppParams::pixFmtTxt + fi)))
				mPixFormats.AddItem((void *)(AppParams::pixFmtTxt + fi));

	::free(listModes);

	int32 nPixFormats = mPixFormats.CountItems();
	float pixFmtYDim = (nPixFormats / PIXFORMAT_GRID_COLUMNS + (nPixFormats % PIXFORMAT_GRID_COLUMNS ? 1 : 0)) * PIXFORMAT_GRID_Y;

	// adjust window's size and position
	ResizeBy(0, pixFmtYDim);
	MoveTo(((*screen).Frame().Width() - Bounds().Width()) * .5f, ((*screen).Frame().Height() - Bounds().Height()) * .5f);

	delete screen;

	// background view
	BView *viewBackgr = new BView(BRect(0, 0, WINDOW_XDIM - 1, WINDOW_YDIM + pixFmtYDim - 1), NULL, B_FOLLOW_NONE, B_WILL_DRAW);
	(*viewBackgr).SetViewColor(::ui_color(B_PANEL_BACKGROUND_COLOR));

	// group box(es)
	BBox *boxFramework = new BBox(BRect(FRMWRKVIEW_X0, FRMWRKVIEW_Y0, FRMWRKVIEW_X1, FRMWRKVIEW_Y1));
	BBox *boxPixFormat = new BBox(BRect(PIXFMTVIEW_X0, PIXFMTVIEW_Y0, PIXFMTVIEW_X1, PIXFMTVIEW_Y0 +
										PIXFORMAT_MARGIN_Y * 1.7f + pixFmtYDim - 1), PIXFMTVIEW_NAME);
	(*boxFramework).SetLabel(FRMWRKVIEW_LABEL);
	(*boxPixFormat).SetLabel(PIXFMTVIEW_LABEL);
	(*boxFramework).SetFont(::be_plain_font, B_FONT_ALL);
	(*boxPixFormat).SetFont(::be_plain_font, B_FONT_ALL);

	// controls...
	BMessage *message;

	// ...num_ring_buffers
	BString strText;
	strText << mParams.frameworkParams.numRingBuffers;

	BString strLabel;
	strLabel << RINGBUFFCTRL_LABEL << " (from " << MIN_NUM_RING_BUFFERS << " to " << MAX_NUM_RING_BUFFERS << "): ";

	message = new BMessage(MSG_CMD_CONTROL_CHANGED);
	(*message).AddInt8(MSG_FLD_INVOKED, INVOKED_RINGBUFFCTRL);

	BTextControl *ctrlRingBuffers =
		new BTextControl(BRect(RINGBUFFCTRL_X0, RINGBUFFCTRL_Y0, RINGBUFFCTRL_X1, RINGBUFFCTRL_Y1),
						 RINGBUFFCTRL_NAME, strLabel.String(), strText.String(), message,
						 B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE | B_NAVIGABLE_JUMP);

	(*ctrlRingBuffers).SetDivider((*ctrlRingBuffers).StringWidth(strLabel.String()));

	BTextView *viewText = (*ctrlRingBuffers).TextView();
	(*viewText).ResizeTo((*viewText).StringWidth(RINGBUFFCTRL_TXT_SIZER), (*viewText).Bounds().Height());

	// ...null framework
	message = new BMessage(MSG_CMD_CONTROL_CHANGED);
	(*message).AddInt8(MSG_FLD_INVOKED, INVOKED_FRMWRKCTRL_NULL);

	BRadioButton *ctrlFrmwrk_null =
		new BRadioButton(BRect(FRMWRKCTRL_NULL_X0, FRMWRKCTRL_NULL_Y0, FRMWRKCTRL_NULL_X1, FRMWRKCTRL_NULL_Y1),
						FRMWRKCTRL_NULL_NAME, FRMWRKCTRL_NULL_LABEL, message);

	(*ctrlFrmwrk_null).ResizeToPreferred();

	EmbossStringView *lblFrmwrk_null =
		new EmbossStringView(BRect(FRMWRKCTRL_NULL_X0 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_NULL_Y0,
								   FRMWRKCTRL_NULL_X1 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_NULL_Y1),
							 NULL, FRMWRKCTRL_NULL_DESC);

	(*lblFrmwrk_null).ResizeToPreferred();
	(*lblFrmwrk_null).SetHighColor(::tint_color(::ui_color(B_MENU_ITEM_TEXT_COLOR), B_DISABLED_MARK_TINT));
	(*lblFrmwrk_null).SetLowColor(::ui_color(B_PANEL_BACKGROUND_COLOR));
	(*lblFrmwrk_null).SetViewColor(::ui_color(B_PANEL_BACKGROUND_COLOR));

	// ...bview framework
	message = new BMessage(MSG_CMD_CONTROL_CHANGED);
	(*message).AddInt8(MSG_FLD_INVOKED, INVOKED_FRMWRKCTRL_BVIEW);

	BRadioButton *ctrlFrmwrk_bview =
		new BRadioButton(BRect(FRMWRKCTRL_BVIEW_X0, FRMWRKCTRL_BVIEW_Y0, FRMWRKCTRL_BVIEW_X1, FRMWRKCTRL_BVIEW_Y1),
						FRMWRKCTRL_BVIEW_NAME, FRMWRKCTRL_BVIEW_LABEL, message);

	(*ctrlFrmwrk_bview).ResizeToPreferred();

	EmbossStringView *lblFrmwrk_bview =
		new EmbossStringView(BRect(FRMWRKCTRL_BVIEW_X0 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BVIEW_Y0,
								   FRMWRKCTRL_BVIEW_X1 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BVIEW_Y1),
							 NULL, FRMWRKCTRL_BVIEW_DESC);

	(*lblFrmwrk_bview).ResizeToPreferred();
	(*lblFrmwrk_bview).SetHighColor(::tint_color(::ui_color(B_MENU_ITEM_TEXT_COLOR), B_DISABLED_MARK_TINT));
	(*lblFrmwrk_bview).SetLowColor(::ui_color(B_PANEL_BACKGROUND_COLOR));
	(*lblFrmwrk_bview).SetViewColor(::ui_color(B_PANEL_BACKGROUND_COLOR));

	// ...bdirectwindow framework
	message = new BMessage(MSG_CMD_CONTROL_CHANGED);
	(*message).AddInt8(MSG_FLD_INVOKED, INVOKED_FRMWRKCTRL_BDWIN);

	BRadioButton *ctrlFrmwrk_bdwin =
		new BRadioButton(BRect(FRMWRKCTRL_BDWIN_X0, FRMWRKCTRL_BDWIN_Y0, FRMWRKCTRL_BDWIN_X1, FRMWRKCTRL_BDWIN_Y1),
						FRMWRKCTRL_BDWIN_NAME, FRMWRKCTRL_BDWIN_LABEL, message);

	(*ctrlFrmwrk_bdwin).ResizeToPreferred();

	EmbossStringView *lblFrmwrk_bdwin =
		new	EmbossStringView(BRect(FRMWRKCTRL_BDWIN_X0 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BDWIN_Y0,
								   FRMWRKCTRL_BDWIN_X1 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BDWIN_Y1),
							 NULL, FRMWRKCTRL_BDWIN_DESC);

	(*lblFrmwrk_bdwin).ResizeToPreferred();
	(*lblFrmwrk_bdwin).SetHighColor(::tint_color(::ui_color(B_MENU_ITEM_TEXT_COLOR), B_DISABLED_MARK_TINT));
	(*lblFrmwrk_bdwin).SetLowColor(::ui_color(B_PANEL_BACKGROUND_COLOR));
	(*lblFrmwrk_bdwin).SetViewColor(::ui_color(B_PANEL_BACKGROUND_COLOR));

	// ...bdirectwindowlc framework
	message = new BMessage(MSG_CMD_CONTROL_CHANGED);
	(*message).AddInt8(MSG_FLD_INVOKED, INVOKED_FRMWRKCTRL_BDWINLC);

	BRadioButton *ctrlFrmwrk_bdwinlc =
		new BRadioButton(BRect(FRMWRKCTRL_BDWINLC_X0, FRMWRKCTRL_BDWINLC_Y0, FRMWRKCTRL_BDWINLC_X1, FRMWRKCTRL_BDWINLC_Y1),
						FRMWRKCTRL_BDWINLC_NAME, FRMWRKCTRL_BDWINLC_LABEL, message);

	(*ctrlFrmwrk_bdwinlc).ResizeToPreferred();

	EmbossStringView *lblFrmwrk_bdwinlc =
		new EmbossStringView(BRect(FRMWRKCTRL_BDWINLC_X0 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BDWINLC_Y0,
								   FRMWRKCTRL_BDWINLC_X1 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BDWINLC_Y1),
							 NULL, FRMWRKCTRL_BDWINLC_DESC);

	(*lblFrmwrk_bdwinlc).ResizeToPreferred();
	(*lblFrmwrk_bdwinlc).SetHighColor(::tint_color(::ui_color(B_MENU_ITEM_TEXT_COLOR), B_DISABLED_MARK_TINT));
	(*lblFrmwrk_bdwinlc).SetLowColor(::ui_color(B_PANEL_BACKGROUND_COLOR));
	(*lblFrmwrk_bdwinlc).SetViewColor(::ui_color(B_PANEL_BACKGROUND_COLOR));

	// ...bwindowscreen framework
	message = new BMessage(MSG_CMD_CONTROL_CHANGED);
	(*message).AddInt8(MSG_FLD_INVOKED, INVOKED_FRMWRKCTRL_BWINSCR);

	BRadioButton *ctrlFrmwrk_bwinscr =
		new BRadioButton(BRect(FRMWRKCTRL_BWINSCR_X0, FRMWRKCTRL_BWINSCR_Y0, FRMWRKCTRL_BWINSCR_X1, FRMWRKCTRL_BWINSCR_Y1),
						FRMWRKCTRL_BWINSCR_NAME, FRMWRKCTRL_BWINSCR_LABEL, message);

	(*ctrlFrmwrk_bwinscr).ResizeToPreferred();

	EmbossStringView *lblFrmwrk_bwinscr =
		new EmbossStringView(BRect(FRMWRKCTRL_BWINSCR_X0 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BWINSCR_Y0,
								   FRMWRKCTRL_BWINSCR_X1 + FRMWRK_DESC_OFFSET_X, FRMWRKCTRL_BWINSCR_Y1),
							 NULL, FRMWRKCTRL_BWINSCR_DESC);

	(*lblFrmwrk_bwinscr).ResizeToPreferred();
	(*lblFrmwrk_bwinscr).SetHighColor(::tint_color(::ui_color(B_MENU_ITEM_TEXT_COLOR), B_DISABLED_MARK_TINT));
	(*lblFrmwrk_bwinscr).SetLowColor(::ui_color(B_PANEL_BACKGROUND_COLOR));
	(*lblFrmwrk_bwinscr).SetViewColor(::ui_color(B_PANEL_BACKGROUND_COLOR));

	// ...available pixel format(s)
	for (int32 i = 0; i < mPixFormats.CountItems(); i++)
	{ 
		message = new BMessage(MSG_CMD_CONTROL_CHANGED);
		(*message).AddInt8(MSG_FLD_INVOKED, INVOKED_PIXFMTCTRL_BASE + i);
	
		float x0 = PIXFORMAT_MARGIN_X + (i % PIXFORMAT_GRID_COLUMNS) * PIXFORMAT_GRID_X;
		float y0 = PIXFORMAT_MARGIN_Y + (i / PIXFORMAT_GRID_COLUMNS) * PIXFORMAT_GRID_Y;

		BRadioButton *ctrlPixFormat =
			new BRadioButton(BRect(x0, y0, x0 + 99, y0 + 19), NULL,
							 ((AppParams::PixelFormatText *) mPixFormats.ItemAt(i))->textual, message);
	
		(*ctrlPixFormat).ResizeToPreferred();
		(*boxPixFormat).AddChild(ctrlPixFormat);

		// make note of the radio button for the desktop pixel format
		if (((AppParams::PixelFormatText *) mPixFormats.ItemAt(i))->space == desktopColorSpace)
			mDesktopPixFormat = ctrlPixFormat;
	}

	// link the window hierarchy
	(*boxFramework).AddChild(ctrlFrmwrk_null);
	(*boxFramework).AddChild(ctrlFrmwrk_bview);
	(*boxFramework).AddChild(ctrlFrmwrk_bdwin);
	(*boxFramework).AddChild(ctrlFrmwrk_bdwinlc);
	(*boxFramework).AddChild(ctrlFrmwrk_bwinscr);

	(*boxFramework).AddChild(lblFrmwrk_null);
	(*boxFramework).AddChild(lblFrmwrk_bview);
	(*boxFramework).AddChild(lblFrmwrk_bdwin);
	(*boxFramework).AddChild(lblFrmwrk_bdwinlc);
	(*boxFramework).AddChild(lblFrmwrk_bwinscr);

	(*viewBackgr).AddChild(ctrlRingBuffers);
	(*viewBackgr).AddChild(boxFramework);
	(*viewBackgr).AddChild(boxPixFormat);
	AddChild(viewBackgr);

	// update controls' state to actual parameters
	switch(mParams.frameworkType)
	{
	case FRAMEWORK_NULL:

		(*ctrlFrmwrk_null).SetValue(B_CONTROL_ON);
		(*ctrlRingBuffers).SetEnabled(false);

		EnableRadioButtons(PIXFMTVIEW_NAME);
		(*mDesktopPixFormat).SetValue(B_CONTROL_ON);
		break;

	case FRAMEWORK_BVIEW:

		(*ctrlFrmwrk_bview).SetValue(B_CONTROL_ON);

		EnableRadioButtons(PIXFMTVIEW_NAME);
		(*mDesktopPixFormat).SetValue(B_CONTROL_ON);
		break;

	case FRAMEWORK_BDIRECTWINDOW:

		(*ctrlFrmwrk_bdwin).SetValue(B_CONTROL_ON);

		DisableRadioButtons(PIXFMTVIEW_NAME, mDesktopPixFormat);
		break;

	case FRAMEWORK_BDIRECTWINDOW_LC:

		(*ctrlFrmwrk_bdwinlc).SetValue(B_CONTROL_ON);

		DisableRadioButtons(PIXFMTVIEW_NAME, mDesktopPixFormat);
		break;

	case FRAMEWORK_BWINDOWSCREEN:

		(*ctrlFrmwrk_bwinscr).SetValue(B_CONTROL_ON);

		EnableRadioButtons(PIXFMTVIEW_NAME);
		(*mDesktopPixFormat).SetValue(B_CONTROL_ON);
		break;
	}
}

SetupWindow::~SetupWindow()
{
	/* all BViews in this window's hierarchy deleted on BWindow::Quit() */
}

bool SetupWindow::QuitRequested()
{
	// update the UI first
	Hide();
	Sync();

	// read back the framework controls
	BRadioButton *ctrlFrmwrk_null = dynamic_cast<BRadioButton *> (FindView(FRMWRKCTRL_NULL_NAME));
	BRadioButton *ctrlFrmwrk_bview = dynamic_cast<BRadioButton *> (FindView(FRMWRKCTRL_BVIEW_NAME));
	BRadioButton *ctrlFrmwrk_bdwin = dynamic_cast<BRadioButton *> (FindView(FRMWRKCTRL_BDWIN_NAME));
	BRadioButton *ctrlFrmwrk_bdwinlc = dynamic_cast<BRadioButton *> (FindView(FRMWRKCTRL_BDWINLC_NAME));
	BRadioButton *ctrlFrmwrk_bwinscr = dynamic_cast<BRadioButton *> (FindView(FRMWRKCTRL_BWINSCR_NAME));

	if (NULL != ctrlFrmwrk_null && (*ctrlFrmwrk_null).Value() == B_CONTROL_ON)
		mParams.frameworkType = FRAMEWORK_NULL;
	else
	if (NULL != ctrlFrmwrk_bview && (*ctrlFrmwrk_bview).Value() == B_CONTROL_ON)
		mParams.frameworkType = FRAMEWORK_BVIEW;
	else
	if (NULL != ctrlFrmwrk_bdwin && (*ctrlFrmwrk_bdwin).Value() == B_CONTROL_ON)
		mParams.frameworkType = FRAMEWORK_BDIRECTWINDOW;
	else
	if (NULL != ctrlFrmwrk_bdwinlc && (*ctrlFrmwrk_bdwinlc).Value() == B_CONTROL_ON)
		mParams.frameworkType = FRAMEWORK_BDIRECTWINDOW_LC;
	else
	if (NULL != ctrlFrmwrk_bwinscr && (*ctrlFrmwrk_bwinscr).Value() == B_CONTROL_ON)
		mParams.frameworkType = FRAMEWORK_BWINDOWSCREEN;

	// read back num_ring_buffers control
	BTextControl *ctrlRingBuff = dynamic_cast<BTextControl *> (FindView(RINGBUFFCTRL_NAME));

	if (NULL != ctrlRingBuff)
	{
		int32 value;
		if (1 == ::sscanf((*ctrlRingBuff).Text(), "%ld", &value))
		{
			if (MIN_NUM_RING_BUFFERS > value)
				value = MIN_NUM_RING_BUFFERS;
			else
			if (MAX_NUM_RING_BUFFERS < value)
				value = MAX_NUM_RING_BUFFERS;

			mParams.frameworkParams.numRingBuffers = value;
		}
	}

	// read back the pixel format controls
	BBox *boxPixFormat = dynamic_cast<BBox *> (FindView(PIXFMTVIEW_NAME));
	
	if (boxPixFormat != NULL)
	{
		int32 pixFmtIdx = 0;

		for (BView *child = (*boxPixFormat).ChildAt(0); child != NULL; child = (*child).NextSibling())
		{
			BRadioButton *button = dynamic_cast<BRadioButton *>(child);

			if (button != NULL)
				if ((*button).Value() == B_CONTROL_ON)
				{
					mParams.frameworkParams.pixelFormat = ((AppParams::PixelFormatText *) mPixFormats.ItemAt(pixFmtIdx))->space;
					break;
				}
				else
					pixFmtIdx++;
		}
	}

	return BWindow::QuitRequested();
}

void SetupWindow::MessageReceived(BMessage *message)
{
	switch((*message).what)
	{
	case MSG_CMD_CONTROL_CHANGED:

		// note: since we handle here invocation notifications of controls residing only in this very window's BLooper,
		// doing so should be perfectly synchronous; it should be ok to access those controls' values from here.

		int8 invoked;
		if (B_OK == (*message).FindInt8(MSG_FLD_INVOKED, &invoked))
		{
			BTextControl *ctrlRingBuff = dynamic_cast<BTextControl *> (FindView(RINGBUFFCTRL_NAME));

			switch(invoked)
			{
			case INVOKED_RINGBUFFCTRL:

				// adjust control's value as necessary
				if (ctrlRingBuff != NULL)
				{
					int32 value;
					if (1 == ::sscanf((*ctrlRingBuff).Text(), "%ld", &value))
					{
						if (MIN_NUM_RING_BUFFERS > value)
							value = MIN_NUM_RING_BUFFERS;
						else
						if (MAX_NUM_RING_BUFFERS < value)
							value = MAX_NUM_RING_BUFFERS;

						mParams.frameworkParams.numRingBuffers = value;
					}

					BString str;
					str << mParams.frameworkParams.numRingBuffers;

					(*ctrlRingBuff).SetText(str.String());
				}
				break;

			case INVOKED_FRMWRKCTRL_NULL:		// disable num_ring_buffers control and enable pixel format controls

				if (ctrlRingBuff != NULL)
				{
					(*ctrlRingBuff).SetEnabled(false);
					(*ctrlRingBuff).MakeFocus(false);
					// above loss of focus causes a subsequent invokation of the respective control
				}
				EnableRadioButtons(PIXFMTVIEW_NAME);
				break;

			case INVOKED_FRMWRKCTRL_BDWIN:
			case INVOKED_FRMWRKCTRL_BDWINLC: 	// enable num_ring_buffers control and disable pixel format controls

				if (ctrlRingBuff != NULL)
					(*ctrlRingBuff).SetEnabled(true);

				DisableRadioButtons(PIXFMTVIEW_NAME, mDesktopPixFormat);
				break;

			case INVOKED_FRMWRKCTRL_BVIEW:
			case INVOKED_FRMWRKCTRL_BWINSCR:	// enable num_ring_buffers control and pixel format controls

				if (ctrlRingBuff != NULL)
					(*ctrlRingBuff).SetEnabled(true);

				EnableRadioButtons(PIXFMTVIEW_NAME);
				break;
			}
		}
		break;

	default:
		BWindow::MessageReceived(message); 
	}
}

void SetupWindow::EnableRadioButtons(const char *groupViewName) const
{
	BView *groupView = FindView(groupViewName);

	if (groupView != NULL)
		for (BView *child = (*groupView).ChildAt(0); child != NULL; child = (*child).NextSibling())
		{
			BRadioButton *button = dynamic_cast<BRadioButton *>(child);
			if (button != NULL)
				(*button).SetEnabled(true);
		}
}

void SetupWindow::DisableRadioButtons(const char *groupViewName, BRadioButton *buttonOn) const
{
	BView *groupView = FindView(groupViewName);

	if (groupView != NULL)
		for (BView *child = (*groupView).ChildAt(0); child != NULL; child = (*child).NextSibling())
		{
			BRadioButton *button = dynamic_cast<BRadioButton *>(child);
			if (button != NULL)
			{
				(*button).SetEnabled(false);

				if (button == buttonOn)
					(*button).SetValue(B_CONTROL_ON);
			}
		}
}
