#ifndef __RENDHELPER__
#define __RENDHELPER__

// VecSize()		: returns the size of a vector
//		VECTOR_T					: one of Vector* types
// returns
//		int
template < typename VECTOR_T >
inline int VecSize()
{
	return sizeof(VECTOR_T) / sizeof(float);
}

// Swap()			: swaps two variables of the same type
//		COMMON_T					: a type to perform the swapping on
//		- a,		<COMMON_T> &	: 1st veriable,		input/output
//		- b,		<COMMON_T> &	: 2nd veriable,		input/output
// returns
//		nil
template < typename COMMON_T >
inline void Swap(COMMON_T &a, COMMON_T &b)
{
	COMMON_T tmp = a;
	a = b;
	b = tmp;
}

// Max()		: returns the greater of two variables of the same type
//		COMMON_T					: a type to perform the comparison on
//		- a,	const <COMMON_T> &	: 1st veriable,		input
//		- b,	const <COMMON_T> &	: 2nd veriable,		input
// returns
//		const <COMMON_T> &
template < typename COMMON_T >
inline const COMMON_T& Max(const COMMON_T& a, const COMMON_T& b)
{
	return a < b ? b : a;
} 

#endif // __RENDHELPER__
